<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加产线',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加产线' : '编辑'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref } from "vue";
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  workshopId: [
    { required: true, message: "请选择车间名称", trigger: "change" },
  ],
  type: [{ required: true, message: "请选择产线类型", trigger: "change" }],
  name: [{ required: true, message: "请输入产线名称", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "车间",
    prop: "workshopId",
    data: [],
  },
  {
    label: "产线类型",
    prop: "type",
    data: [
      {
        label: "普通产线",
        value: "1",
      },
      {
        label: "半自动化产线",
        value: "2",
      },
      {
        label: "自动化产线",
        value: "3",
      },
    ],
  },
]);
const config = computed(() => {
  return [
    {
      attrs: {
        label: "车间名称",
        prop: "workshopName",
        width: 120,
      },
    },
    {
      attrs: {
        label: "产线类型",
        prop: "type",
        width: 150,
      },
      render(type) {
        return type == 1
          ? "普通产线"
          : type == 2
          ? "半自动化产线"
          : type == "3"
          ? "自动化产线"
          : "";
      },
    },
    {
      attrs: {
        label: "产线名称",
        prop: "name",
        width: 150,
      },
    },
    {
      attrs: {
        label: "负责人",
        prop: "personLiableName",
        width: 100,
      },
    },
    {
      attrs: {
        label: "产线说明",
        prop: "remarks",
      },
    },

    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/assemblyLine/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = computed(() => {
  return [
    {
      type: "select",
      prop: "workshopId",
      label: "车间名称",
      required: true,
      isLoad: {
        url: "/workshop/page",
        req: {
          pageNum: 1,
          pageSize: 9999,
        },
        labelKey: "name",
        labelVal: "id",
        method: "post",
        resUrl: "rows",
      },
    },
    {
      type: "select",
      prop: "type",
      label: "产线类型",
      required: true,
      data: [
        {
          label: "普通产线",
          value: "1",
        },
        {
          label: "半自动化产线",
          value: "2",
        },
        {
          label: "自动化产线",
          value: "3",
        },
      ],
    },
    {
      type: "input",
      prop: "name",
      label: "产线名称",
      required: true,
    },
    {
      type: "select",
      prop: "personLiableId",
      label: "负责人",
      isLoad: {
        url: "/system/user/list?pageNum=1&pageSize=10000",
        labelKey: "userName",
        labelVal: "userId",
        method: "get",
        resUrl: "rows",
      },
    },
    {
      type: "input",
      prop: "remarks",
      label: "产线说明",
      itemType: "textarea",
    },
  ];
});
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/assemblyLine/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
  console.log(formData.data, "awss");
};

const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    proxy.post("/assemblyLine/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/assemblyLine/detail", { id: row.id }).then((res) => {
    res.type = res.type + "";
    formData.data = res;
    console.log(formData);
    dialogVisible.value = true;
  });
};

const selectData = reactive({
  farmList: [],
});
const getSelect = () => {
  proxy
    .post("/workshop/page", { pageNum: 1, pageSize: 9999 })
    .then((message) => {
      selectData.farmList = message.rows;
      selectConfig[0].data = selectData.farmList.map((x) => ({
        label: x.name,
        value: x.id,
      }));
    });
};

getList();
getSelect();
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>